/* $Id$ */

#ifndef __extern_h
#define __extern_h

/*#####################*/
/*# Diagnostic module #*/
/*#####################*/

#ifdef __slidstat_h
extern int  diag_init(char *peDiag);
extern int  diagnosis(PROCSTAT *psArray, int iRound);
extern void diag_close(void);
#endif

/*##########*/
/*# TOPO.C #*/
/*##########*/

extern int init_2DMesh(int *nProcs, char *nNeighbors, char *peTop);
extern int init_3DMesh(int *nProcs, char *nNeighbors, char *peTop);
extern int init_Hyper(int *nProcs, char *nNeighbors, char *peTop);
extern int init_binTree(int *nProcs, char *nNeighbors, char *peTop);
extern int init_DsAring(int *nProcs, char *nNeighbors, char *peTop);
extern int init_Syst3deg(int *nProcs, char *nNeighbors, char *peTop);
extern int init_Syst6deg(int *nProcs, char *nNeighbors, char *peTop);

extern int neighbor_2DGrid(int iProc, char iNeighbor);
extern int neighbor_2DTorus(int iProc, char iNeighbor);
extern int neighbor_2DFolded(int iProc, char iNeighbor);
extern int neighbor_3DGrid(int iProc, char iNeighbor);
extern int neighbor_3DTorus(int iProc, char iNeighbor);
extern int neighbor_Hyper(int iProc, char iNeighbor);
extern int neighbor_binTree(int iProc, char iNeighbor);
extern int neighbor_DsAring(int iProc, char iNeighbor);
extern int neighbor_Systolic(int iProc, char iNeighbor);

extern int back_2DGrid(int iProc, char iNeighbor);
extern int back_2DTorus(int iProc, char iNeighbor);
extern int back_2DFolded(int iProc, char iNeighbor);
extern int back_3DGrid(int iProc, char iNeighbor);
extern int back_3DTorus(int iProc, char iNeighbor);
extern int back_binTree(int iProc, char iNeighbor);
extern int back_DsAring(int iProc, char iNeighbor);
extern int back_Systolic(int iProc, char iNeighbor);

/*############*/
/*# INJECT.C #*/
/*############*/

#ifdef __slidstat_h
extern void init_inval(PROCSTAT *psArray, char iType);
extern int  invalidate(PROCSTAT *psArray, int iTester, int iDUT);

extern PROCTAB * evendist(PROCSTAT *psArray, int fMax, int fgMax);
extern PROCTAB * determin(PROCSTAT *psArray, int fMax, int fgMax);
extern PROCTAB * physical(PROCSTAT *psArray, int fMax, int fgMax);
extern PROCTAB * physwcf(PROCSTAT *psArray, int fMax, int fgMax);
extern PROCTAB * in1gl(PROCSTAT *psArray, int fMax, int fgMax);
extern PROCTAB * in1ga(PROCSTAT *psArray, int fMax, int fgMax);
extern PROCTAB * inmgl(PROCSTAT *psArray, int fMax, int fgMax);
extern PROCTAB * inmga(PROCSTAT *psArray, int fMax, int fgMax);
#endif

/*###########*/
/*# PARAM.C #*/
/*###########*/

extern void help(char *pHN, char *pFrom, char *pTo);

extern void      clpar(int parc, char *parv[]);
extern void      envpar(void);
extern void      sfpar(char pSN[]);
extern PROCTAB * sfsels(char pSN[]);

extern void disppar(void);
extern void logppar(char *pFN);
extern void dispstat(char *title, STDATA *pStat);
extern void recstat(char *pFN, STDATA *pStat);
extern int  clfile(char *pFN, char *pXparm[], void *pXpnt[]);

/*###########*/
/*# PARSE.C #*/
/*###########*/

#ifdef __slidlist_h
extern int scanentry(char *pFN);

extern int load_inval(PROCSTAT *psArray, LTETYPE *pType, LTENTRY *pEntry);
extern int load_faults(PROCSTAT *psArray, LTETYPE *pType, LTENTRY *pEntry);
extern int load_misdiag(PROCSTAT *psArray, LTETYPE *pType, LTENTRY *pEntry);
extern int load_problems(PROCSTAT *psArray, LTETYPE *pType, LTENTRY *pEntry);
#endif

/*#############*/
/*# DISPLAY.C #*/
/*#############*/

#ifdef __slidlist_h
extern void dispgrid(PROCSTAT *psArray, char *dbuf[], void (*dsp_proc)());

extern void dps_2DMesh(PROCSTAT *psArray, char *dbuf[], int iProc);
extern void dps_2DFolded(PROCSTAT *psArray, char *dbuf[], int iProc);
extern void dinv_2DMesh(PROCSTAT *psArray, char *dbuf[], int iProc);
extern void dstat_2DMesh(PROCSTAT *psArray, char *dbuf[], int iProc);
extern void dps_3DMesh(PROCSTAT *psArray, char *dbuf[], int iProc);
extern void dps_Syst6deg(PROCSTAT *psArray, char *dbuf[], int iProc);
#endif

#endif
