# $Id$
#
# Makefile.gnu
#   of the SLIDSTAT (System-level LID simulation + STATistics), and
#   of the SLIDLIST (SLIDSTAT results lister) programs

SHELL   = /bin/sh

CC      = gcc
CFLAGS += $(OPTS) $(DEFS)
OPTS    = -g -Wall -std=gnu99
DEFS    = -D_UNIX_ -D_ANSI_ -D_VERBOSE_
TAR     = tar

SSRCS1  = slidstat.c random.c io.c topo.c search.c inject.c param.c
SSRCS2  = diagnose.c
SOBJS1  = $(SSRCS1:.c=.o)
SOBJS2  = $(SSRCS2:.c=.o)
SOBJS   = $(SOBJS1) $(SOBJS2)
STRGS1  = $(SSRCS1:.c=)
STRGS2  = $(SSRCS2:.c=)
SLIBS   = -lm

LSRCS   = slidlist.c io.c topo.c param.c parse.c display.c
LOBJS   = $(LSRCS:.c=.o)

all:		$(STRGS2)

diagnose:	diagnose.o $(SOBJS1)
		$(CC) -o $@ $@.o $(SOBJS1) $(SLIBS)

slidstat:	$(SOBJS)
		$(CC) -o $@ $(SOBJS) $(SLIBS)

slidlist:	$(LOBJS)
		$(CC) -o $@ $(LOBJS) $(SLIBS)

clean:
		rm -f *.bak *.BAK *~ *.o a.out

tar:
		$(TAR) -zcvf `vername lid tgz` $(SSRCS1) $(SSRCS2) $(LSRCS)

$(SOBJS1):	slidstat.h slidlist.h proto.h
slidstat.o:	random.h topo.h extern.h
random.o:	random.h
topo.o:		topo.h
search.o:	search.h
inject.o:	random.h topo.h search.h

$(SOBJS2):	slidstat.h proto.h

$(LOBJS):	slidstat.h slidlist.h proto.h
slidlist.o:	topo.h extern.h

.SUFFIXES:
.SUFFIXES: .c .o .h
