/* $Id$ */

#ifndef __proto_h
#define __proto_h

/*#####################*/
/*# Diagnostic module #*/
/*#####################*/

#ifdef __slidstat_h
int  diag_init(char *peDiag);
int  diagnosis(PROCSTAT *psArray, int iRound);
#ifdef _ANSI_
void diag_close(void);
#else
void diag_close();
#endif
#endif

/*########*/
/*# IO.C #*/
/*########*/

int      strstrip(char *pString);
char   * getspstr(char *pSN, char *pSect, char *pProp);
int      getspint(char *pSN, char *pSect, char *pProp);
char   * getststr(char *pYN, char *pParm);
long     getstlong(char *pYN, char *pParm);
double   getstdouble(char *pYN, char *pParm);

/*##########*/
/*# TOPO.C #*/
/*##########*/

int init_2DMesh(int *nProcs, char *nNeighbors, char *peTop);
int init_3DMesh(int *nProcs, char *nNeighbors, char *peTop);
int init_Hyper(int *nProcs, char *nNeighbors, char *peTop);
int init_binTree(int *nProcs, char *nNeighbors, char *peTop);
int init_DsAring(int *nProcs, char *nNeighbors, char *peTop);
int init_Syst3deg(int *nProcs, char *nNeighbors, char *peTop);
int init_Syst6deg(int *nProcs, char *nNeighbors, char *peTop);

int neighbor_2DGrid(int iProc, char iNeighbor);
int neighbor_2DTorus(int iProc, char iNeighbor);
int neighbor_2DFolded(int iProc, char iNeighbor);
int neighbor_3DGrid(int iProc, char iNeighbor);
int neighbor_3DTorus(int iProc, char iNeighbor);
int neighbor_Hyper(int iProc, char iNeighbor);
int neighbor_binTree(int iProc, char iNeighbor);
int neighbor_DsAring(int iProc, char iNeighbor);
int neighbor_Systolic(int iProc, char iNeighbor);

int back_2DGrid(int iProc, char iNeighbor);
int back_2DTorus(int iProc, char iNeighbor);
int back_2DFolded(int iProc, char iNeighbor);
int back_3DGrid(int iProc, char iNeighbor);
int back_3DTorus(int iProc, char iNeighbor);
int back_binTree(int iProc, char iNeighbor);
int back_DsAring(int iProc, char iNeighbor);
int back_Systolic(int iProc, char iNeighbor);

/*############*/
/*# SEARCH.C #*/
/*############*/

#ifdef __search_h
NODETAB *  sbrfs(char nDepth, int iRoot);
int       _rbrfs(NODETAB *pnTable, int nNodes, char nDepth, int iLevel, int iRoot, char cNode, int n);
NODETAB *  rbrfs(char nDepth, int iRoot);
#endif

/*############*/
/*# INJECT.C #*/
/*############*/

#ifdef __slidstat_h
void init_inval(PROCSTAT *psArray, char iType);
int  invalidate(PROCSTAT *psArray, int iTester, int iDUT);

PROCTAB * evendist(PROCSTAT *psArray, int fMax, int fgMax);
PROCTAB * determin(PROCSTAT *psArray, int fMax, int fgMax);
PROCTAB * physical(PROCSTAT *psArray, int fMax, int fgMax);
PROCTAB * physwcf(PROCSTAT *psArray, int fMax, int fgMax);
PROCTAB * in1gl(PROCSTAT *psArray, int fMax, int fgMax);
PROCTAB * in1ga(PROCSTAT *psArray, int fMax, int fgMax);
PROCTAB * inmgl(PROCSTAT *psArray, int fMax, int fgMax);
PROCTAB * inmga(PROCSTAT *psArray, int fMax, int fgMax);
#endif

/*###########*/
/*# PARAM.C #*/
/*###########*/

void help(char *pHN, char *pFrom, char *pTo);

void      clpar(int parc, char *parv[]);
#ifdef _ANSI_
void      envpar(void);
#else
void      envpar();
#endif
void      sfpar(char pSN[]);
PROCTAB * sfsels(char pSN[]);

#ifdef _ANSI_
void disppar(void);
#else
void disppar();
#endif
void logppar(char *pFN);
void dispstat(char *title, STDATA *pStat);
void recstat(char *pFN, STDATA *pStat);
int  clfile(char *pFN, char *pXparm[], void *pXpnt[]);

/*###########*/
/*# PARSE.C #*/
/*###########*/

#ifdef __slidlist_h
int scanentry(char *pFN);

int load_inval(PROCSTAT *psArray, LTETYPE *pType, LTENTRY *pEntry);
int load_faults(PROCSTAT *psArray, LTETYPE *pType, LTENTRY *pEntry);
int load_misdiag(PROCSTAT *psArray, LTETYPE *pType, LTENTRY *pEntry);
int load_problems(PROCSTAT *psArray, LTETYPE *pType, LTENTRY *pEntry);
#endif

/*#############*/
/*# DISPLAY.C #*/
/*#############*/

#ifdef __slidlist_h
void dispgrid(PROCSTAT *psArray, char *dbuf[], void (*dsp_proc)(PROCSTAT *psArray, char *dbuf[], int iProc));

void dps_2DMesh(PROCSTAT *psArray, char *dbuf[], int iProc);
void dps_2DFolded(PROCSTAT *psArray, char *dbuf[], int iProc);
void dinv_2DMesh(PROCSTAT *psArray, char *dbuf[], int iProc);
void dstat_2DMesh(PROCSTAT *psArray, char *dbuf[], int iProc);
void dps_3DMesh(PROCSTAT *psArray, char *dbuf[], int iProc);
void dps_Syst6deg(PROCSTAT *psArray, char *dbuf[], int iProc);
#endif

#endif
