/* $Id$ */

#ifndef __random_h
#define __random_h

/*###########*/
/*# Defines #*/
/*###########*/

#define RAD2PI  6.28318531
#define LN2     0.69314718

#ifdef  _UNIX_

#ifndef RAND_MAX
#warning RAND_MAX is not defined!

#define RAND_MAX     0x7FFFFFFF
#define MAX_RANDOM   2147483647.0
#define MAX_RAND4    8589934588.0
#define FACTOR       (-21.5)

#define urnd(range)  ((int)floor((range)*(rand()/MAX_RANDOM)))
#define ernd(range)  ((int)floor((double)(range)*log(0.25 - (rand()/MAX_RAND4))/FACTOR))

#else

#define FACTOR       (-21.5)

#define urnd(range)  ((int)floor((range)*(rand()/(double)RAND_MAX)))
#define ernd(range)  ((int)floor((double)(range)*log(0.25 - (rand()/(4.0*(double)RAND_MAX)))/FACTOR))

#endif

#ifdef  _LCG_
#warning Using LCG library...

#define LCG_A             16807
#define LCG_M        2147483647L
#define Random()     mlcg_gen()
#define Srandom(x)   mlcg_set(x)

#else

#define Random()     rand()
#define SRandom(x)   srand((unsigned)x)
#endif

#else

#ifndef RAND_MAX
#define RAND_MAX    0x7FFF
#endif

#warning RAND_MAX

#define MAX_RANDOM   32768.0
#define MAX_RAND4   131072.0
#define FACTOR      (-11.8)

#define Random()     rand()
#define SRandom(x)   srand((unsigned)x)
#define urnd(range)  ((int)floor((range)*(rand()/(double)MAX_RANDOM)))
#define ernd(range)  ((int)floor((double)(range)*log(0.25 - (rand()/(double)MAX_RAND4))/FACTOR))

#endif

#endif
