/* $Id$ */

#ifndef __slidlist_h
#define __slidlist_h

/*#############*/
/*# Constants #*/
/*#############*/

#define CMDLEN          5
#define DBUFSIZE        5
#define DBUFLEN      1023

#define TYPE_INVALP    11
#define TYPE_FAULTP    12
#define TYPE_MISDP     13
#define TYPE_PROBS     21
#define TYPE_SPROBS    22

/*###########*/
/*# Defines #*/
/*###########*/

#define chrput(d,s)  *(d) = s;
#define strput(d,s)  strncpy(d, s, strlen(s))

/*############*/
/*# Typedefs #*/
/*############*/

struct parms {
    int   nRounds;
    int   nRepeats;
    int   nProcs;
    int   fMax, fgMax;
    char  iType;
    float tfrFG, tfrFF;
    char  nTopology;
    char  nInjector;
    char  peInv[NUM_STRING];
    char  peTop[NUM_STRING];
    char  peInj[NUM_STRING];
    char  peDiag[NUM_STRING];
    float cCoeff;
};

typedef struct ltentry {
    long            ePos;							/* Entry: file position        */
    int             oNum;							/*        ordinal number       */
    unsigned int    iPar1;							/*        parameter #1         */
    unsigned int    iPar2;							/*        parameter #2         */
    unsigned int    iPar3;							/*        parameter #3         */
    char            nPar;							/*        number of parameters */
    struct ltentry *pNext;							/*        next sublist item    */
} LTENTRY;
#define LTENSIZE sizeof(LTENTRY)

typedef struct ltetype {
    char           *pFN;							/* Name of file containing this entry */
    int             iType;							/* Entry: type                        */
    LTENTRY        *pFirst;							/*        first list entry            */
    LTENTRY        *pLast;                                                      /*        last  list entry            */
    int             nEntry;							/*        number of entries           */
    int             cEntry;							/*        currently examined entry    */
    struct ltetype *pNext;							/*        next list item              */
} LTETYPE;
#define LTETSIZE sizeof(LTETYPE)

struct types {
    LTETYPE *pType;								/* Statistics List: entry type              */
    int      nType;								/*                  number of entry types   */
    int      cType;								/*                  currently examined type */
};

#endif
