/* $Id$ */

#ifndef __topo_h
#define __topo_h

/*############*/
/*# Typedefs #*/
/*############*/

/*::::::::::::::::::::::::*/
/*:: 2D mesh topologies ::*/
/*::::::::::::::::::::::::*/

typedef struct mesh_2D {
    int  xMax;									/* Maximal X dimension  */
    int  yMax;									/*         Y dimension  */
    char dirc[4];								/* Direction conversion */
} TD2D;

#define MAX_NB2DM  4
#define m2DX       Mesh_2D.xMax
#define m2DY       Mesh_2D.yMax
#define m2Dc       Mesh_2D.dirc

/*::::::::::::::::::::::::*/
/*:: 3D mesh topologies ::*/
/*::::::::::::::::::::::::*/

typedef struct mesh_3D {
    int  xMax;									/* Maximal X dimension  */
    int  yMax;									/*         Y dimension  */
    int  zMax;									/*         Z dimension  */
    char dirc[6];								/* Direction conversion */
} TD3D;

#define MAX_NB3DM  6
#define m3DX       Mesh_3D.xMax
#define m3DY       Mesh_3D.yMax
#define m3DZ       Mesh_3D.zMax
#define m3Dc       Mesh_3D.dirc

/*:::::::::::::::::::::::::::*/
/*:: D(s, A) ring topology ::*/
/*:::::::::::::::::::::::::::*/

typedef struct ring_DsA {
    int  s;									/* Neighbor modulus */
    int  A;									/*          number  */
} TDFR;

#define rings  Ring_DsA.s
#define ringA  Ring_DsA.A

/*:::::::::::::::::::::*/
/*:: Systolic arrays ::*/
/*:::::::::::::::::::::*/

typedef struct syst_mesh {
    int  xMax;									/* Maximal X dimension  */
    int  yMax;									/*         Y dimension  */
    char dirc[2][6];								/* Direction conversion */
} TDSA;

#define mSMX  Syst_Mesh.xMax
#define mSMY  Syst_Mesh.yMax
#define mSMc  Syst_Mesh.dirc

#endif
